#include "personal_urbanosfere.h"

/* Служебные функции над перс.урбан.:
 * - объединение
 * - пересечение
 * - включение
 * - равенство
 * - симметрическая разность
 * - растяжение
 * - концентрация
 * - множество альфа-уровня
 * - четкое множество, ближайшее к нечеткому */

struct PERSONAL_URBANOSFERE *unionPU(
		struct PERSONAL_URBANOSFERE *result_pu,
		const struct PERSONAL_URBANOSFERE *added_pu);

/* Служебные функции над частями перс.урбан.:
 * - объединение частей
 * - выделение части */

/* РЕАЛИЗАЦИЯ СЛУЖЕБНЫХ ФУНКЦИЙ */





/* РЕАЛИЗАЦИЯ ФУНКЦИЙ */
char equalPU(const struct PERSONAL_URBANOSFERE *first_pu,
		const struct PERSONAL_URBANOSFERE *second_pu,
		const char flag_name, const struct POINT *delta_coord,
		const time_t delta_time) {
	/* Сравниваем параметры перс.урбан.
	 * Условие станет неверным при использовании полигонов */
	if (first_pu->areas_count != second_pu->areas_count ||
			first_pu->paths_count != second_pu->paths_count)
		return 0;
	int count = 0;
	/* Сравнение областей */
	for (count = 0; count < first_pu->areas_count; count++) {
		int i = 0;
		for (i = 0; i < second_pu->areas_count; i++) {
			/* Сравниваем с учетом погрешности */
			if (isEqualArea(&first_pu->areas[count],
					&second_pu->areas[i], flag_name,
					delta_coord, delta_time)) {
				/* Сравниваем принадлежность перс.урб.
				 * умножаем чтобы сравнить MUDIFF числа*/
				if (first_pu->areas[count].mu * MUDIFF !=
						second_pu->areas[i].mu *
						MUDIFF)
					return 0;
			}
		}
	}
	/* Сравнение путей */
	for (count = 0; count < first_pu->paths_count; count++) {
		int i = 0;
		for (i = 0; i < second_pu->paths_count; i++) {
			if (equalPath(&first_pu->paths[count],
					&second_pu->paths[i], flag_name,
					delta_coord, delta_time)) {
				if (first_pu->paths[count].mu * MUDIFF !=
						second_pu->paths[i].mu *
						MUDIFF)
					return 0;
			}
		}
	}
	/* Все совпало, они равны */
	return 1;
}

struct PERSONAL_URBANOSFERE *unionPU(
		struct PERSONAL_URBANOSFERE *result_pu,
		const struct PERSONAL_URBANOSFERE *added_pu) {
	/* Сравнивать и искать такую же, если есть в других границах,
	 * расширять по максимуму. Имя использовать из result_pu */
	return result_pu;
}

