#include "point.h"
#include <stdlib.h>
#include <string.h>

struct POINT *createPoints(const int count) {
	struct POINT *sp = calloc(count, sizeof(struct POINT));
	return sp;
}

void destroyPoints(struct POINT *points) {
	free(points);
}

void fillPoint(struct POINT *point, const float x, const float y,
		const float z, const int radius, const char add) {
	point->x = x;
	point->y = y;
	point->z = z;
	point->radius = radius;
	point->add = add;
}

char isEqualPoint(const struct POINT *first, const struct POINT *second,
		const struct POINT *delta) {
	/* Определение разности со всеми допусками */
	if (second->x > first->x + delta->x)
		return 0;
	if (second->x < first->x - delta->x)
		return 0;
	if (second->y > first->y + delta->y)
		return 0;
	if (second->y < first->y - delta->y)
		return 0;
	if (second->z > first->z + delta->z)
		return 0;
	if (second->z < first->z - delta->z)
		return 0;
	if (second->radius > first->radius + delta->radius)
		return 0;
	if (second->radius < first->radius - delta->radius)
		return 0;
	if (second->add != first->add)
		return 0;
	return 1;
}

struct POINT *addPoint(struct POINT *points, const int points_count,
		const struct POINT *point) {
	struct POINT *ps = calloc(points_count + 1, sizeof(struct POINT));
	memcpy(ps, points, sizeof(struct POINT) * points_count);
	memcpy(&ps[points_count], point, sizeof(struct POINT));
	destroyPoints(points);
	return ps;
}

/* Удаление точки */
struct POINT *deletePoint(struct POINT *points, const int points_count,
		const struct POINT *point) {
	int count;
	for (count = 0; count < points_count; count++) {
		if (points[count].x == point->x &&
				points[count].y == point->y &&
				points[count].z == point->z &&
				points[count].radius == point->radius &&
				points[count].add == point->add)
			break;
	}
	/* Если точка найдена */
	if (count < points_count) {
		int del_index = count;
		int new_count = 0;
		struct POINT *temp = calloc(points_count-1,
				sizeof(struct POINT));
		for (count = 0; count < points_count; count++) {
			/* Пропускаем удаляемую точку */
			if (count != del_index) {
				memcpy(&temp[new_count], &points[count],
					sizeof(struct POINT));
				new_count++;
			}
		}
		destroyPoints(points);
		points = temp;
	}
	return points;
}

