#ifndef POINT_H
#define POINT_H

#include <stdint.h>

#pragma pack(push, 1)
struct POINT {
	float x;
	float y;
	float z;
	int radius; /* радиус в метрах */
	char add; /* 1 - добавляет, 0 - удаляет */
};
#pragma pack(pop)

struct POINT *createPoints(const int count);
void destroyPoints(struct POINT *points);
void fillPoint(struct POINT *point, const float x, const float y,
		const float z, const int radius, const char add);

/* Функции для работы с точками */
char isEqualPoint(const struct POINT *first, const struct POINT *second,
		const struct POINT *delta);

/* Добавление точки */
struct POINT *addPoint(struct POINT *points, const int points_count,
		const struct POINT *point);

/* Удаление точки */
struct POINT *deletePoint(struct POINT *points, const int points_count,
		const struct POINT *point);

#endif

